#!/usr/bin/perl
print "usage: runreveicer.pl runs address duration\n" if (@ARGV != 3);

$hname = "$ENV{HOST}";
# $logdir = "$ENV{HOME}/tfm/log";
# chdir $logdir;

@tcpnum = (1, 2, 4, 10,  1, 10);
@udpnum = (1, 2, 4, 10, 10,  1);

$syncport = 27520;
$portsuffix = 58;
$portsuffix1 = 59;
$delay = 0;
$duration = $ARGV[2];

for ($num = 0; $num < @udpnum; ++$num) {
    print "$ARGV[0] x ($tcpnum[$num] x tcp, $udpnum[$num] x udp) to $ARGV[1]\n";
    $dumpcmd = "tcpdump -n 'host $hname and (port";

    for ($i = 0; $i < $udpnum[$num]; ++$i) {
	$port = $i + 100;
	$dumpcmd = "$dumpcmd or" if ($i > 0);
	$dumpcmd = "$dumpcmd $port$portsuffix or $port$portsuffix1";
    }
    for ($i = 0; $i < $tcpnum[$num]; ++$i) {
	$port = $i + 200;
	$dumpcmd = "$dumpcmd or" if ($i > 0 || $udpnum[$num] > 0);
	$dumpcmd = "$dumpcmd $port$portsuffix or $port$portsuffix1";
    }
    $dumpcmd = "$dumpcmd)' > net.log &";

    system "mkdir $tcpnum[$num]$udpnum[$num]";
    chdir "$tcpnum[$num]$udpnum[$num]";

    print "waiting for sender...\n";
    sleep 5; # start sender in meantime !
    for ($simnr = 1; $simnr <= $ARGV[0]; ++$simnr) {
	system "tcpsender $ARGV[1] $syncport";
	die "ERROR: sync. failed\n" if ($? >> 8 != 0);
	print "synchronized\n";
	print "$dumpcmd\n";
	system "$dumpcmd";

	for ($i = 0; $i < $udpnum[$num]; ++$i) {
	    $port = $i + 100;
	    $inr = $i + 1;
	    system "receiver $ARGV[1] $port$portsuffix -t " . ($duration + 10) . " -n $inr -w 8 &";
	}

	for ($i = 0; $i < $tcpnum[$num]; ++$i) {
	    $port = $i + 200;
	    system "tcpreceiver ${port}${portsuffix} -t " . ($duration + 10). " &";
	}

	sleep ($duration + 10);
	system "stopall.sh tcp";
	sleep 10;
	system "killall tcpdump";
	system "stopall.sh \" \"";
	sleep 20;
	system "movelog.sh $simnr";
    }
    chdir "..";
}
